#include "zpfft.h"

#define reg register double
#define V *(volatile const double *)&

static void doroots(zpfft_p *c)
{
  reg t0, t1, t2, t3;
  int i;

  t0 = 1.0;
  t2 = c->zeta[1];

  for (i = 0;i < 256;i += 2) {
    c->roots[i] = t0;
    t0 *= c->zeta[0];
    c->roots[i + 1] = t2;
    t2 *= c->zeta[0];
    t1 = c->pinv;
    t1 *= t0;
    t3 = c->pinv;
    t3 *= t2;
    t1 += c->alpha0;

    t3 += c->alpha0;
    t1 -= c->alpha0;

    t3 -= c->alpha0;
    t1 *= c->p;

    t3 *= c->p;
    t0 -= t1;

    t2 -= t3;
  }

  c->roots[256] = t0; /* -1 */
}

void zpfft_init(zpfft_p *c,double p,double zeta)
{
  c->p = p;
  c->alpha0 = 13835058055282163712.0;
  c->pinv = 1.0 / p;
  c->zeta[12] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[11] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[10] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[9] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[8] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[7] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[6] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[5] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[4] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[3] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[2] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[1] = zeta; zeta = zpfft_product(c,zeta,zeta);
  c->zeta[0] = zeta;
  doroots(c);
  zeta = -c->roots[254];
  c->zetainv[0] = zeta; zeta = zpfft_product(c,zeta,c->zeta[1]);
  c->zetainv[1] = zeta; zeta = zpfft_product(c,zeta,c->zeta[2]);
  c->zetainv[2] = zeta; zeta = zpfft_product(c,zeta,c->zeta[3]);
  c->zetainv[3] = zeta; zeta = zpfft_product(c,zeta,c->zeta[4]);
  c->zetainv[4] = zeta; zeta = zpfft_product(c,zeta,c->zeta[5]);
  c->zetainv[5] = zeta; zeta = zpfft_product(c,zeta,c->zeta[6]);
  c->zetainv[6] = zeta; zeta = zpfft_product(c,zeta,c->zeta[7]);
  c->zetainv[7] = zeta; zeta = zpfft_product(c,zeta,c->zeta[8]);
  c->zetainv[8] = zeta; zeta = zpfft_product(c,zeta,c->zeta[9]);
  c->zetainv[9] = zeta; zeta = zpfft_product(c,zeta,c->zeta[10]);
  c->zetainv[10] = zeta; zeta = zpfft_product(c,zeta,c->zeta[11]);
  c->zetainv[11] = zeta; zeta = zpfft_product(c,zeta,c->zeta[12]);
  c->zetainv[12] = zeta;
}
