#include "zpfft.h"
#include "bitrev.h"

/* Y must be a multiple of 4. */

#define reg register double
#define V *(volatile const double *)&

static double space[Y + Y + Y + 1];

void F_XY(register const zpfft_p *c,register double *u)
{
  register double *q;
  reg t0, t1, t2, t3, t4, t5, t6, t7;
  register int j;
  register int jX;
  int i;

  for (i = 0;i < XY;i += X)
    F_X(c,u + i);

  q = space;
  if (4 & (int) (char *) q)
    q = (double *)(4 + (char *) q);

  for (j = 0;j < Y;++j)
    q[j + Y] = 1.0;

  t0 = 1.0;
  for (j = 0;j < Y;++j) {
    q[BITREV_Y[j] + Y + Y] = t0;
    t0 *= ZETA_XY;
    t1 = c->pinv;
    t1 *= t0;
    t1 += c->alpha0;
    t1 -= c->alpha0;
    t1 *= c->p;
    t0 -= t1;
  }

  for (i = 0;i < X;++i) {
    jX = 0;
    j = 0;
    do {
      t0 = u[i + jX];
      t0 *= q[j + Y];
      t2 = u[i + jX + X];
      t2 *= q[j + 1 + Y];
      t4 = u[i + jX + 2 * X];
      t4 *= q[j + 2 + Y];
      t6 = u[i + jX + 3 * X];
      t6 *= q[j + 3 + Y];
      t1 = c->pinv;
      t1 *= t0;
      t3 = c->pinv;
      t3 *= t2;
      t5 = c->pinv;
      t5 *= t4;
      t7 = c->pinv;
      t7 *= t6;
      t1 += c->alpha0;
      t3 += c->alpha0;
      t5 += c->alpha0;
      t1 -= c->alpha0;
      t7 += c->alpha0;
      t3 -= c->alpha0;
      t1 *= c->p;
      t5 -= c->alpha0;
      t3 *= c->p;
      t7 -= c->alpha0;
      t5 *= c->p;
      t0 -= t1;
      t7 *= c->p;
      t2 -= t3;
      t4 -= t5;
      t6 -= t7;
      q[j] = t0;
      q[j + 1] = t2;
      q[j + 2] = t4;
      q[j + 3] = t6;

      t0 = q[j + Y];
      t0 *= q[j + Y + Y];
      t2 = q[j + 1 + Y];
      t2 *= q[j + 1 + Y + Y];
      t4 = q[j + 2 + Y];
      t4 *= q[j + 2 + Y + Y];
      t6 = q[j + 3 + Y];
      t6 *= q[j + 3 + Y + Y];
      t1 = c->pinv;
      t1 *= t0;
      t3 = c->pinv;
      t3 *= t2;
      t5 = c->pinv;
      t5 *= t4;
      t7 = c->pinv;
      t7 *= t6;
      t1 += c->alpha0;
      t3 += c->alpha0;
      t5 += c->alpha0;
      t1 -= c->alpha0;
      t7 += c->alpha0;
      t3 -= c->alpha0;
      t1 *= c->p;
      t5 -= c->alpha0;
      t3 *= c->p;
      t7 -= c->alpha0;
      t5 *= c->p;
      t0 -= t1;
      t7 *= c->p;
      t2 -= t3;
      t4 -= t5;
      t6 -= t7;
      q[j + Y] = t0;
      q[j + 1 + Y] = t2;
      q[j + 2 + Y] = t4;
      q[j + 3 + Y] = t6;

      j += 4;
      jX += 4 * X;
    } while (j < Y);

    F_Y(c,q);

    j = 0;
    jX = 0;
    do {
      t0 = q[j];
      t2 = q[j + 1];
      t4 = q[j + 2];
      t6 = q[j + 3];
      u[i + jX] = t0;
      u[i + jX + 1 * X] = t2;
      u[i + jX + 2 * X] = t4;
      u[i + jX + 3 * X] = t6;
      jX += 4 * X;
      j += 4;
    } while (j < Y);
  }
}
